/*--------------------------------
 * 
 * Jerome.Gouzy@inra.fr
 * Created: 20140407
 * Copyright INRA, All rights reserved
 * 
 * $Id: sequencesethash.h 449 2014-12-24 17:05:19Z gouzy $
 * 
 ---------------------------------*/



#ifndef SEQUENCESETHASH_H

#define SEQUENCESETHASH_H

#include "uthash.h" // Copyright (c) 2005-2014, Troy D. Hanson  http://troydhanson.github.com/uthash/ All rights reserved.
#include "general.h"
#include "sequenceset.h"

typedef struct sequencesethash
{
	seqid_t id;
	char *sequence;
//	float qualscore; 		// moyenne des occurences de kmer
	UT_hash_handle hh; 
} sequencesethash_t;

typedef struct seqidlenhash
{
	seqid_t      id;
	unsigned int len;
	UT_hash_handle hh; 
} seqidlenhash_t;


void 	DeleteSequenceSetHash(sequencesethash_t **h_seqset);
char 	*GetSeqHash(sequencesethash_t **seqset,seqid_t id);
void 	SetSeqHash(sequencesethash_t **seqset,seqid_t id,char *seq);
void 	SetQualHash(sequencesethash_t **seqset,seqid_t id,float qualscore);
int 	MoveSeqHash(sequencesethash_t **seqset_src,sequencesethash_t **seqset_dst,seqid_t id);
int 	SeqSortByLenHash(sequencesethash_t *a,sequencesethash_t *b);
int 	SeqidLenSortByLen(seqidlenhash_t *a,seqidlenhash_t *b);
int     SeqSortByQualHash(sequencesethash_t *a,sequencesethash_t *b);
void 	DuplicateSeqSetIntoSeqSetHash(sequenceset_t **src,sequencesethash_t **dst,seqid_t nb_seq_max);
seqid_t GetMaxSeqIdHash(sequencesethash_t **seqset);

#endif